/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import flash.display.Sprite;
	import com.demonsters.debugger.MonsterDebugger;
	
	public class Config
	{
		private static var _oInstance : Config = null;// contient l'instance unique de la classe
		private static var allowInstance:Boolean = false; // empêche l'instanciation de la classe à partir du constructeur
 
 
		/* paramètres de notre classe de Configuration */
		private var oSpriteDebug:Sprite;
		private var oVueInter1:Sprite;
		private var oVueInter2:Sprite;
		
		
 
		/**
		 * Returns singleton instance of <code>Config</code> class.
		 *
		 * @return The singleton instance of <code>Config</code> class.
		 */
		public static function getInstance() : Config
		{
			// si l'instance n'existe pas, on la crée
			if ( !(Config._oInstance is Config) )
			{
				allowInstance = true;// autorise la création d'une instance
				Config._oInstance = new Config();
				allowInstance = false;// désactive la création d'autre instance
			}
 
			// renvoie toujours la même instance de la classe
			return Config._oInstance;
		}
 
		/**
		 * Constructeur
		 */
		public function Config() : void
		{
			if (!allowInstance)// test s'il est possible d'instancier la classe
			{
				MonsterDebugger.trace(this, 'This class cannot be instantiated from the constructor' );
				// throw new Error ('This class cannot be instantiated from the constructor');
			}
		}
		
		
		/**
		 * Définis les display objet utilisés par les vues et le debug.
		 * 
		 */
		public function setDisplay( oVuesInterface1:Sprite, oVuesInterface2:Sprite,oDebug:Sprite) : void
		{
			oVueInter1 = oVuesInterface1;
			oVueInter2 = oVuesInterface2;
			oSpriteDebug = oDebug;
		}


		/**
		 * Renvoie le display objet pour toutes les interfaces graphiques de l'application.
		 * 
		 */
		public function getDisplayInter1() : Sprite 
		{
			return oVueInter1;
		}
		

		/**
		 * Renvoie le display objet pour toutes les interfaces graphiques de l'application.
		 * 
		 */
		public function getDisplayInter2() : Sprite 
		{
			return oVueInter2;
		}
				

		/**
		 * Renvoie le display objet pour le debug.
		 * 
		 */
		public function getDisplayDebug() : Sprite 
		{
			return oSpriteDebug;
		}
		
		
	}
}
